declare('SmartJett', SmartJett or {})
declare('KombatTunes', KombatTunes or {})


local useKombat = true --switch to false if you intend to use the plugin without the kombattunes sound support (essentially sounds won't be played)
local stopat100 = false --switch to false if you want to disengage smartjett when you reach 100% mission ore mined(normally it is disengaged when the mission is terminated docking at the station)

local xxv = false
local l = false
local lxxv = false
local c = false
local percent = 0
local count = 0
local needed = 0
local isMission = false
local smartActive = false
local jettActive = false
local dropAll = false
local ore = {
	['Premium Aquean Ore'] = false,
	['Premium Silicate Ore'] = false,
	['Premium Carbonic Ore'] = false,
	['Premium Ferric Ore'] = false,
	['Premium Ishik Ore'] = false,
	['Premium VanAzek Ore'] = false,
	['Premium Xithricite Ore'] = false,
	['Lanthanic Ore'] = false,
	['Denic Ore'] = false,
	['Pyronic Ore'] = false,
	['Apicene Ore'] = false,
	['Pentric Ore'] = false,
	['Heliocene Ore'] = false,
}

local names = {
  [1] = 'Aquean',
  [2] = 'Silicate',
  [3] = 'Carbonic',
  [4] = 'Ferric',
  [5] = 'Ishik',
  [6] = 'VanAzek',
  [7] = 'Xithricite',
  [8] = 'Lanthanic',
  [9] = 'Denic',
  [10] = 'Pyronic',
  [11] = 'Apicene',
  [12] = 'Pentric',
  [13] = 'Heliocene',
}

  

function translate(abb)
  local orename = ""
  if      abb == 'aq' then orename = 'Premium Aquean Ore'
  elseif  abb == 'si' then orename = 'Premium Silicate Ore'
  elseif  abb == 'ca' then orename = 'Premium Carbonic Ore'
  elseif  abb == 'fe' then orename = 'Premium Ferric Ore'
  elseif  abb == 'is' then orename = 'Premium Ishik Ore'
  elseif  abb == 'va' then orename = 'Premium VanAzek Ore'
  elseif  abb == 'xi' then orename = 'Premium Xithricite Ore'
  elseif  abb == 'la' then orename = 'Lanthanic Ore'
  elseif  abb == 'de' then orename = 'Denic Ore'
  elseif  abb == 'py' then orename = 'Pyronic Ore'
  elseif  abb == 'ap' then orename = 'Apicene Ore'
  elseif  abb == 'pe' then orename = 'Pentric Ore'
  elseif  abb == 'he' then orename = 'Heliocene Ore'
  end 
 return orename
end

function IsValid(missioninfo)

  local valid = false
  for v,k in pairs(missioninfo) do
  for a,j in pairs(k) do
    if ((string.match(j,"Ore") ~= nil or string.match(j,"mine") ~= nil or string.match(j,"Mine") ~= nil) and (string.match(j,"prospect" == false))) then
      valid = true
    end
  end
  end
  return valid
end

function FindOre(missiontbl)
 
  local oretemp
  local found
  local isFound = false
  for v,k in pairs(missiontbl) do
    for x,z in pairs(k) do
    for a,j in pairs(names) do
    oretemp = string.match(z,j)
      if (oretemp ~= nil and isFound == false) then
        if (a < 8) then
          local oretemp ="Premium "..j.." Ore"
          ore[oretemp] = true
          found = oretemp
          isFound = true
        elseif (isFound == false) then  
          ore[j.." Ore"] = true
          found = j.." Ore"
        end
      end
    end
    end
  end
  print(found)
end

function FindQty(missiontbl)

  local qty1,tqty1
  local tmp
  for a,j in pairs(missiontbl) do
	   for v,k in pairs(j) do
	     tqty1 = string.match(k,"(%d+)%scubic%sunits")
	     if (tqty1 == nil) then
	       tqty1 = string.match(k,"(%d+)cu")
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 == nil) then
	       tqty1 =string.match(k,'(%d+)%scrates')
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 == nil) then
	       tqty1 =string.match(k,'load%stotal%sof%s(%d+)')
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 == nil) then
	       tqty1 =string.match(k,"(%d+)%scu")
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 == nil) then
	       tqty1 =string.match(k,"(%d+)%stotal%sunits")
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 == nil) then
	       tqty1 =string.match(k,"(%d+)%sfresh%sunits")
	     else
	       qty1 = tqty1
	     end
	     if (tqty1 ~= nil) then
	       qty1 = tqty1
	     end
	   end
	 end
return qty1
end
    
function GetMissionInfo()

  local name,info,id = GetActiveMissionInfo(1)
  
  if (IsValid(info) == true) then
  
      print("\127ffffff".."\nThe following ores have been detected: ")
      FindOre(info)
    
      print("\nQuantity needed: ")
      needed = FindQty(info)
      print(needed.."\n")
      
      isMission = true
      
      RegisterEvent(SmartJett,"MISSION_REMOVED")
      
   else
      print("You have accept a non-mining mission")
   end
end

function HandleMission()

  if (isMission == true) then
    percent = (count/needed)*100
    print(percent)
    
    if (percent>=25 and percent<50 and xxv == false) then
      if (useKombat == true) then
        KombatTunes.new("25")
      end
      print("\127ffffffMission at 25%")
      xxv = true
    end
    
    if (percent>=50 and percent<75 and l == false) then
      if (useKombat == true) then
        KombatTunes.new("50")
      end
      print("\127ffffffMission at 50%")
      l = true
    end
    
    if (percent>=75 and percent<100 and lxxv == false) then
      if (useKombat == true) then
        KombatTunes.new("75")
      end
      print("\127ffffffMission at 75%")
      lxxv = true
    end
    
    if (percent == 100 and c == false) then
      if (useKombat == true) then
        KombatTunes.new("100")
      end
      print("\127ffffffMission completed")
      c = true
      if (stopat100 == true) then
        Reset()
      end
    end
  end
end

function SmartJett:INVENTORY_ADD(event,itemid)

  	if PlayerInStation() == false and jettActive == true then
		   local itemname = GetInventoryItemName(itemid)
		   if ore[itemname] == false then
			JettisonSingle(itemid, 1)
			  end
			  if (smartActive == true and ore[itemname] == true) then
			      count = count + 1
			      HandleMission()
			  end
  end
end

function SmartJett:INVENTORY_UPDATE(event,itemid)

  	if PlayerInStation() == false and jettActive == true then
		   local itemname = GetInventoryItemName(itemid)
		   if ore[itemname] == false then
			JettisonSingle(itemid, 1)
			  end
			  if (smartActive == true and ore[itemname] == true) then
			    count = count + 1
			    HandleMission()
			  end
  end
end

function Reset()
  for v,k in pairs(ore) do
    k = false
  end
  
  xxv = false
  l = false
  lxxv = false
  c = false
  percent = 0
  count = 0
  needed = 0
  if (isMission == true) then  UnregisterEvent(SmartJett,"MISSION_REMOVED")
  end 
  isMission = false
end

function SmartJett:MISSION_REMOVED(event,data)
  Reset()
end

function SmartJett:MISSION_ADDED(event,data)
 if(smartActive == true) then
  RegisterEvent(SmartJett,"MISSION_UPDATED")
 end 
end

function SmartJett:MISSION_UPDATED(event,data)
  if (smartActive == true) then
    UnregisterEvent(SmartJett,"MISSION_UPDATED")
    GetMissionInfo()
  end
end

function SmartJett.db(_,data)
  if (smartActive == true) then
    GetMissionInfo()
  end
end

function SmartJett.cmd(_,data)

  if not data then
    print("\127ffffffCommand usage: /sj aj, /sj autojett, /sj sj, /sj smartjett")
 
  elseif (data[1] == "sj" or data[1] == "smartjett") then
    if (jettActive == false and smartActive == false) then
      jettActive = true
      smartActive = true
      RegisterEvent(SmartJett,"MISSION_ADDED")
      print("\127ffffffSmartJett engaged")
    
    elseif (jettActive == true and smartActive == true) then
      jettActive = false
      smartActive = false
      Reset()
      UnregisterEvent(SmartJett,"MISSION_ADDED")
      print("\127ffffffSmartJett disengaged")
      
    elseif (jettActive == true and smartActive == false) then
      print("\127ffffffPlease, disable standard autojett with /sj aj or /sj autojett first(Variable reset needed).")
    end
    
  elseif (data[1] == "aj" or data[1] == "autojett") then
    if (jettActive == true and smartActive == false) then
      jettActive = false
      Reset()
      print("\127ffffffAutojett disengaged")
    elseif (jettActive == false and smartActive == false) then
      if not data[2] then
        print('\127ffffffUsage: /sj aj "ore1" "ore2" ecc.. or /sj autojett "ore1" "ore2" ecc.. All ore names are detected using the fist 2 letters of the name eg. VanAzek = va, Ferric = fe.')
      else 
        jettActive = true
        print("\127ffffffAutojett engaged. Now autojettisoning: ")
        local start = 2
        for start,k in pairs(data) do
          ore[translate(k)] = true
          print(translate(k).." ")
        end
        print(" ")
      end
    end
  else print("\127ffffffThe inserted command was not found")
  end
end

RegisterEvent(SmartJett, "INVENTORY_ADD")
RegisterEvent(SmartJett, "INVENTORY_UPDATE")
RegisterUserCommand("smartjett",SmartJett.cmd)
RegisterUserCommand("sj",SmartJett.cmd)
RegisterUserCommand("sjforce",SmartJett.db)

